package net.micode.notes.gtask.data;

import android.database.Cursor;
import android.util.Log;

import net.micode.notes.tool.GTaskStringUtils;

import org.json.JSONException;
import org.json.JSONObject;


public class MetaData extends Task {
    private final static String TAG = MetaData.class.getSimpleName();
    // 类的简写名称存入字符串TAG中，通过调用getSimpleName ()函数实现
    private String mRelatedGid = null;
    // 设置数据，即生成元数据库
    public void setMeta(String gid, JSONObject metaInfo) {
        try {  //将这对键值放入metaInfo这个jsonobject对象中
            metaInfo.put(GTaskStringUtils.META_HEAD_GTASK_ID, gid);
        } catch (JSONException e) { //输出错误信息
            Log.e(TAG, "failed to put related gid");
        }
        setNotes(metaInfo.toString());
        setName(GTaskStringUtils.META_NOTE_NAME);
        //调用Task类中的setNotes ()和setName ()函数
    }
    public String getRelatedGid() {
    //getRelatedGid函数定义
        return mRelatedGid;
    }

    @Override
    public boolean isWorthSaving() {
    //isWorthSaving函数定义
        return getNotes() != null;
    }

    @Override
    public void setContentByRemoteJSON(JSONObject js) {
    //定义setContentByRemoteJSON函数
        super.setContentByRemoteJSON(js);
        if (getNotes() != null) {//判断当前数据是否为空，若为空则返回真即值得保存
            try {
                JSONObject metaInfo = new JSONObject(getNotes().trim());
                mRelatedGid = metaInfo.getString(GTaskStringUtils.META_HEAD_GTASK_ID);
            } catch (JSONException e) {
              //输出警告信息
                Log.w(TAG, "failed to get related gid");
                mRelatedGid = null;
            }
        }
    }

    @Override
    public void setContentByLocalJSON(JSONObject js) {
    //使用本地json数据对象设置元数据内容，一般不会用到，若用到，则抛出异常
        throw new IllegalAccessError("MetaData:setContentByLocalJSON should not be called");//传递非法参数异常
    }

    @Override
    public JSONObject getLocalJSONFromContent() {
    //从元数据内容中获取本地json对象，一般不会用到，若用到，则抛出异常
        throw new IllegalAccessError("MetaData:getLocalJSONFromContent should not be called");
    }

    @Override
    public int getSyncAction(Cursor c) {
    //获取同步动作状态，一般不会用到，若用到，则抛出异常
        throw new IllegalAccessError("MetaData:getSyncAction should not be called");
    }

}
